﻿package {
	/*
	copyright Qwaz(qwazpia@gmail.com)

	MIT License
	TypingPractice Plugin v1.1

	http://blog.naver.com/yechan54/10141371894
	*/
	
	import fl.events.ComponentEvent;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.utils.getTimer;
	
	import com.qwazlab.NamemaN.Plugin;
	
	public class TypingPractice extends Plugin {
		private var list:Vector.<String> = new Vector.<String>;
		private var level:int;
		private var score:int;
		private var prev:int;
		private var next:int;
		private var gap:int;
		private var lastTime:int;
		
		private var nowPlaying:Boolean = false;
		
		private var displaying:Vector.<Word> = new Vector.<Word>;
		
		public function TypingPractice() {
			_pluginName = 'TypingPractice';
			_version = 1.1;
			
			startBtn.addEventListener(MouseEvent.CLICK, gameStart);
			input.addEventListener(ComponentEvent.ENTER, enterDown);
		}
		
		override public function update():void {
			if(!nowPlaying){
				initGame();
				list.splice(0, uint.MAX_VALUE);
				
				updateScore();
			}
		}
		
		override public function convert(input:String):String {
			if(!nowPlaying) list.push(input);
			return input;
		}
		
		private function updateScore():void {
			if(nowPlaying)
				scoreboard.text = score+"점\nLv."+level;
			else
				scoreboard.text = "게임오버\n"+score+"점";
		}
		
		private function gameStart(e:MouseEvent=null):void {
			if(list.length && !nowPlaying){
				updateExternal();
				initGame();
				lastTime = getTimer();
				
				nowPlaying = true;
				updateScore();
				this.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			}
		}
		
		private function initGame():void {
			level = 1;
			score = 0;
			prev = 20;
			next = 10;
			gap = 3000;
			lastTime = getTimer();
		}
		
		private function enterFrameHandler(e:Event):void {
			if(getTimer()-lastTime > gap){
				lastTime += gap;
				
				var word:Word = new Word();
				word.speed = (0.8+Math.random()*0.4)*(0.7+level/7);
				word.text.text = list[int(Math.random()*list.length)];
				word.x = 498+word.width;
				word.y = Math.random()*27;
				displaying.push(word);
				this.addChildAt(word, 0);
				
				word.addEventListener(Event.ENTER_FRAME, wordHandler);
			}
		}
		
		private function wordHandler(e:Event):void {
			var target:Word = e.target as Word;
			
			target.x -= target.speed;
			
			if(target.x < 74){
				nowPlaying = false;
				
				var i:int;
				var len:uint = displaying.length;
				for(i=0; i<len; i++){
					displaying[i].removeEventListener(Event.ENTER_FRAME, wordHandler);
					this.removeChild(displaying[i]);
				}
				displaying.splice(0, uint.MAX_VALUE);
				
				this.removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				
				updateScore();
			}
		}
		
		private function enterDown(e:ComponentEvent):void {
			var i:int;
			var len:uint = displaying.length;
			for(i=0; i<len; i++){
				if(displaying[i].text.text == input.text){
					displaying[i].removeEventListener(Event.ENTER_FRAME, wordHandler);
					this.removeChild(displaying[i]);
					displaying.splice(i, 1);
					
					score += 10;
					if(score == next){
						next += prev;
						prev += 10;
						level++;
						gap -= 100;
					}
					updateScore();
					
					break;
				}
			}
			input.text = '';
		}
	}
}
